/**
* This sample shows how to use the function i_PCI3200_Read1Temperature
**/

#include "stdafx.h"

/* entry point */
int _tmain( int /*argc*/, _TCHAR* /*argv[]*/ )
{
	INT	returnValue = 0;
	HANDLE boardHandle;
	DOUBLE temperature = 0;
	BYTE moduleIndex = 0;
	BYTE channelIndex = 0;
	BYTE sensorType = 0;
	BYTE sensorModel = 0;
	BYTE connectionType = 0;
	ULONG readValue = 0;
	DOUBLE rtdResistance = 0.0;
	BYTE gain = 0;

	/* open a board */
	returnValue = OpenBoard(&boardHandle);
	if (returnValue != 0)
	{
		printf("Error %d opening the board \n", returnValue);
		_getch();
		return -1;
	}

	printf("* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n");
	printf("* This sample enables to show how the i_PCI3200_Read1Temperature works\n");
	printf("* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n\n");

	ReadUlong( "Enter the module index : (0-3)", 0, 3, &readValue);
	moduleIndex = (BYTE) readValue;

	ReadUlong( "Enter the sensor type : (0: TC, 1: RTD)",0,1,&readValue);
	if ( readValue == 0 )
	{
		sensorType = ADDIDATA_THERMOCOUPLE;
		/* single-ended or differential ? */
		ReadUlong( "Enter the connection type : (0: Single Ended, 1: Differential)", 0,1,&readValue);
		if ( readValue == 0 )
		{
			connectionType = APCI3200_CONNECTION_TYPE_SINGLE;
		}
		else
		{
			connectionType = APCI3200_CONNECTION_TYPE_DIFFERENTIAL;
		}
		/* sensor model */
		ReadUlong("Enter the channel type : \n - 0: Type B \n - 1: Type E \n - 2: Type J \n - 3: Type K \n - 4: Type N \n - 5: Type R \n - 6: Type S \n - 7: Type T \n", 0,7,&readValue);
		switch ( readValue )
		{
			case 0:
				sensorModel = ADDIDATA_THERMOCOUPLE_TYPE_B;
				break;
			case 1:
				sensorModel = ADDIDATA_THERMOCOUPLE_TYPE_E;
				break;
			case 2:
				sensorModel = ADDIDATA_THERMOCOUPLE_TYPE_J;
				break;
			case 3:
				sensorModel = ADDIDATA_THERMOCOUPLE_TYPE_K;
				break;
			case 4:
				sensorModel = ADDIDATA_THERMOCOUPLE_TYPE_N;
				break;
			case 5:
				sensorModel = ADDIDATA_THERMOCOUPLE_TYPE_R;
				break;
			case 6:
				sensorModel = ADDIDATA_THERMOCOUPLE_TYPE_S;
				break;
			case 7:
				sensorModel = ADDIDATA_THERMOCOUPLE_TYPE_T;
				break;
		}
	}
	else
	{
		sensorType = ADDIDATA_RTD;
		connectionType = APCI3200_CONNECTION_TYPE_DIFFERENTIAL; /* always differential */
		ReadUlong("Enter the channel type : \n - 0: Type PT \n - 1: Type Ni \n",0,1, &readValue);
		if ( readValue == 0 )
		{
			sensorModel = ADDIDATA_RTD_TYPE_PT;
		}
		else
		{
			sensorModel = ADDIDATA_RTD_TYPE_Ni;
		}
		ReadUlong("Enter the resistance of the sensor : (10-1000)", 10, 1000, &readValue);
		rtdResistance = (DOUBLE)readValue;
	}

	/* the channel index */
	if ( connectionType == APCI3200_CONNECTION_TYPE_DIFFERENTIAL )
	{
		ReadUlong("Enter the channel index : (0-1)", 0, 1, &readValue);
		channelIndex = (BYTE)readValue;
	}
	else
	{
		ReadUlong("Enter the channel index : (0-3)", 0, 3, &readValue);
		channelIndex = (BYTE)readValue;
	}

	ReadUlong("Enter the gain : \n -0: x1 \n -1: x2 \n -2: x4 \n -3: x8 \n -4: x16 \n -5: x32 \n -6: x64 \n -7: x128 \n",0,7, &readValue);
	gain = (BYTE) readValue;

	for(;;)
	{
		/* read the temperature */
		returnValue = i_PCI3200_Read1Temperature( boardHandle, 
			moduleIndex, 
			channelIndex,
			sensorType, 
			sensorModel,
			rtdResistance,
			gain,
			connectionType, 
			20, /* fixed frequency : 20 Hz */
			&temperature );
		if ( returnValue != 0 )
		{
			printf("i_PCI3200_Read1Temperature error : %d \n", returnValue );
			break;
		}
		else
		{
			printf("Temperature : %f Celcius \t\t\r", temperature);
		}

		/* does the user hit a key ?*/
		if ( _kbhit() )
		{
			printf("\n");
			_getch();
			break;
		}
	}

	/* close the board */
	returnValue = i_PCI3200_CloseBoard(boardHandle);
	if ( returnValue != 0 )
	{
		printf("i_PCI3200_CloseBoard error : %d \n", returnValue );
	}
	else
	{
		printf("i_PCI3200_CloseBoard ok. \n");
	}

	_getch();
	/* success */
	return 0;
}

