/**
* This sample shows how to use the function i_PCI3200_GetOpenInputDiagnostic
**/

#include "stdafx.h"

/* entry point */
int _tmain( int /*argc*/, _TCHAR* /*argv[]*/ )
{
	INT	returnValue = 0;
	HANDLE boardHandle;
	BYTE moduleIndex = 0;
	BYTE channelIndex = 0;
	BYTE sensorType = 0;
	BYTE connectionType = 0;
	ULONG readValue = 0;

	/* open a board */
	returnValue = OpenBoard(&boardHandle);
	if (returnValue != 0)
	{
		printf("Error %d opening the board \n", returnValue);
		_getch();
		return -1;
	}

	printf("* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n");
	printf("* This sample enables to show how the i_PCI3200_GetOpenInputDiagnostic works\n");
	printf("* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n\n");

	ReadUlong( "Enter the module index : (0-3)", 0, 3, &readValue);
	moduleIndex = (BYTE) readValue;

	ReadUlong( "Enter the sensor type : (0: TC, 1: RTD)",0,1,&readValue);
	if ( readValue == 0 )
	{
		sensorType = ADDIDATA_THERMOCOUPLE;
		/* single-ended or differential ? */
		ReadUlong( "Enter the connection type : (0: Single Ended, 1: Differential)", 0,1,&readValue);
		if ( readValue == 0 )
		{
			connectionType = APCI3200_CONNECTION_TYPE_SINGLE;
		}
		else
		{
			connectionType = APCI3200_CONNECTION_TYPE_DIFFERENTIAL;
		}
	}
	else
	{
		sensorType = ADDIDATA_RTD;
		connectionType = APCI3200_CONNECTION_TYPE_DIFFERENTIAL; /* always differential */
	}

	/* the channel index */
	if ( connectionType == APCI3200_CONNECTION_TYPE_DIFFERENTIAL )
	{
		ReadUlong("Enter the channel index : (0-1)", 0, 1, &readValue);
		channelIndex = (BYTE)readValue;
	}
	else
	{
		ReadUlong("Enter the channel index : (0-3)", 0, 3, &readValue);
		channelIndex = (BYTE)readValue;
	}

	for(;;)
	{
		BYTE diagnostic = 0;
		/* get the diagnostic */
		returnValue = i_PCI3200_GetOpenInputDiagnostic(boardHandle,
			moduleIndex,
			channelIndex,
			connectionType,
			&diagnostic );
		if ( returnValue != 0 )
		{
			printf("i_PCI3200_GetOpenInputDiagnostic error : %d \n", returnValue );
			break;
		}
		else
		{
			printf("Diagnostic : %d \t\t\r", diagnostic);
		}

		/* does the user hit a key ?*/
		if ( _kbhit() )
		{
			printf("\n");
			_getch();
			break;
		}
	}

	/* close the board */
	returnValue = i_PCI3200_CloseBoard(boardHandle);
	if ( returnValue != 0 )
	{
		printf("i_PCI3200_CloseBoard error : %d \n", returnValue );
	}
	else
	{
		printf("i_PCI3200_CloseBoard ok. \n");
	}

	_getch();
	/* success */
	return 0;
}

