/**
* This sample shows how to use the function i_PCI3200_GetShortCircuitDiagnostic
**/

#include "stdafx.h"

/* entry point */
int _tmain( int /*argc*/, _TCHAR* /*argv[]*/ )
{
	INT	returnValue = 0;
	HANDLE boardHandle;
	BYTE moduleIndex = 0;
	BYTE channelIndex = 0;
	ULONG readValue = 0;

	/* open a board */
	returnValue = OpenBoard(&boardHandle);
	if (returnValue != 0)
	{
		printf("Error %d opening the board \n", returnValue);
		_getch();
		return -1;
	}

	printf("* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n");
	printf("* This sample enables to show how the i_PCI3200_GetShortCircuitDiagnostic works\n");
	printf("* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n\n");

	ReadUlong( "Enter the module index : (0-3)", 0, 3, &readValue);
	moduleIndex = (BYTE) readValue;

	ReadUlong( "Enter the sensor type : (0: TC, 1: RTD)",0,1,&readValue);
	if ( readValue == 0 )
	{
		printf("Short-circuit diagnostic is not available for TC sensors.\n");
		i_PCI3200_CloseBoard(boardHandle);
		_getch();
		return -1;
	}

	/* the channel index */
	ReadUlong("Enter the channel index : (0-1)", 0, 1, &readValue);
	channelIndex = (BYTE)readValue;

	for(;;)
	{
		BYTE diagnostic = 0;
		/* get the diagnostic */
		returnValue = i_PCI3200_GetShortCircuitDiagnostic(boardHandle,
			moduleIndex,
			channelIndex,
			&diagnostic );
		if ( returnValue != 0 )
		{
			printf("i_PCI3200_GetShortCircuitDiagnostic error : %d \n", returnValue );
			break;
		}
		else
		{
			printf("Diagnostic : %d \t\t\r", diagnostic);
		}

		/* does the user hit a key ?*/
		if ( _kbhit() )
		{
			printf("\n");
			_getch();
			break;
		}
	}

	/* close the board */
	returnValue = i_PCI3200_CloseBoard(boardHandle);
	if ( returnValue != 0 )
	{
		printf("i_PCI3200_CloseBoard error : %d \n", returnValue );
	}
	else
	{
		printf("i_PCI3200_CloseBoard ok. \n");
	}

	_getch();
	/* success */
	return 0;
}

