// Here goes constant declarations
#ifndef __PCI3200_H
#define __PCI3200_H

/* Digital input/output related */
#define	PCI3200_DIGITAL_INPUT_NUMBER			4
#define	PCI3200_DIGITAL_OUTPUT_NUMBER			3

#define APCI3200_DISABLE 0
#define APCI3200_ENABLE 1

//------------------------------------------------------------------------------
/** Sensor class */
#define ADDIDATA_THERMOCOUPLE 0
#define	ADDIDATA_RTD 1

/** Known thermo-couple types */
#define	ADDIDATA_THERMOCOUPLE_TYPE_B 0
#define	ADDIDATA_THERMOCOUPLE_TYPE_E 1
#define	ADDIDATA_THERMOCOUPLE_TYPE_J 2
#define	ADDIDATA_THERMOCOUPLE_TYPE_K 3
#define	ADDIDATA_THERMOCOUPLE_TYPE_N 4
#define	ADDIDATA_THERMOCOUPLE_TYPE_R 5
#define	ADDIDATA_THERMOCOUPLE_TYPE_S 6
#define	ADDIDATA_THERMOCOUPLE_TYPE_T 7

/** known RTD type */
#define	ADDIDATA_RTD_TYPE_PT 0
#define	ADDIDATA_RTD_TYPE_Ni 1

/** Type of connection */
#define	APCI3200_CONNECTION_TYPE_SINGLE 0 /**< Valid only with thermocouple sensors. */
#define APCI3200_CONNECTION_TYPE_DIFFERENTIAL 1 /**< Valid with both RTD and thermocouple. */

//------------------------------------------------------------------------------
/** delay mode */
#define	APCI3200_DELAY_NOT_USED 0	/**< Delay mode is not used. */
#define	APCI3200_DELAY_MODE1_USED 1 	/**< The delay between two SCANs is used. The conversion is started at once, and the delay is used after the first SCAN */

#define APCI3200_UNIT_MS	2 /**< value is in milliseconds. */
#define APCI3200_UNIT_S		3	/**< value is in seconds. */

/** Type of trigger signal */
#define APCI3200_FIRST_LOW_EDGE_START_ALL_SCAN 1
#define APCI3200_FIRST_HIGH_EDGE_START_ALL_SCAN 2
#define APCI3200_FIRST_EDGE_START_ALL_SCAN 3

/** SCAN type */
#define APCI3200_SINGLE_SCAN			0 			/**< Only one SCAN is started after calling up the function. */
#define APCI3200_CONTINUOUS_SCAN		2 	/**< An undefined number of SCANs is started after calling up the function. */

#endif
