using System;
using System.Collections.Generic;
using System.Text;

namespace PCI3200_NET
{
    /// <summary>
    /// Store the data of an end of sequence event
    /// End of sequence event is used when using ReadMoreAnalogInput or Read1AnalogInput with interrupt flag enabled
    /// </summary>
    public class EndOfScanEventArgs
    {
        /// <summary>
        /// Specify if the FIFO has overflow
        /// </summary>
        public byte FifoOverflow;
        /// <summary>
        /// The mask that has generated the interruption
        /// </summary>
        public uint InterruptMask;
        /// <summary>
        /// The interrupt source
        /// </summary>
        public uint InterruptSource;
        /// <summary>
        /// The size of data
        /// </summary>
        public uint ArgsSize;
        /// <summary>
        /// The values
        /// </summary>
        public double[] Args;
        /// <summary>
        /// Create the array
        /// </summary>
        public EndOfScanEventArgs()
        {
            // Maximum size is 4
            this.Args = new double[4];
        }
    }
}
